﻿## Этот файл содержит некоторые настройки, которые могут быть изменены
## дабы придать вашей игре индивидуальности. Конечно, здесь только самые
## широко используемые опции. Поменять можно ещё много всего.
##
## Строчки, начинающиеся с двух символов # -- пояснения. Их раскомменчивать
## не стоит. Строчки, начинающиеся с одного символа # -- закомменченые
## куски кода. Их, если Вам нужно, можно раскомменчивать и подправлять
## под Ваши нужды.

init -1:
    python hide:

        ## Включить инструменты разработчика? Перед отправкой игры
        ## "на золото" этому параметру должно быть присвоенно значение  
        ## False, чтобы игрок не мог читерить, используя эти инструменты.

        config.developer = True
        
        ## Здесь устанавливаются ширина и высота экрана игры.

        config.screen_width = 800
        config.screen_height = 600

        ### Здесь устанавливается заголовок окна игры, когда игра работает
        ## в оконном режиме.

        config.window_title = u"Знакомство с Визуальными Новеллами"

        ## Теперь устанавливается используемая игрой схема интерфейса.
        ## roundrect использует скруглённые прямоугольники в качестве
        ## основы элементов интерфейса. Других пока нет...
        ##
        ## Здесь есть несколько параметров, управляющих цветовой схемой,
        ## которые можно настроить по вкусу.

        theme.roundrect(

            ## Цвет невыбранного элемента.
            widget = "#003c78",

            ## Цвет выбранного элемента.
            widget_hover = "#0050a0",

            ## Цвет текста в элементе.
            widget_text = "#c8ffff",

            ## Цвет текста в выбранном элементе. (К примеру,
            ## текущее значение параметра Настроек.)
            widget_selected = "#ffffc8",

            ## Цвет отключённого элемента. 
            disabled = "#404040",

            ## Цвет текста отключённого элемента.
            disabled_text = "#c8c8c8",

            ## Цвет информационных отметок.
            label = "#ffffff",

            ## Цвет рамки, содержащей элементы.
            frame = "#6496c8",

            ## Если этот параметр установлен в True, то игровые меню
            ## будут расположенны по центру экрана. Если же в False, 
            ## то они будут в текстовом окне внизу экрана.
            button_menu = True,

            ## Если этот параметр установлен в True, то текстовое окно 
            ## будет скруглено. Если же в False, то нет.
            rounded_window = False,

            ## Фон главного меню. Может быть какой-либо цвет, в стандартном
            ## шеснадцатиричном RGB-представлении (как по умолчанию), либо
            ## имя файла с изображением (размеры изображения должны 
            ## совпадать с размерами экрана).
            mm_root = "Images/uni.jpg",

            ## Фон внутриигрового меню. Может быть какой-либо цвет, в стандартном
            ## шеснадцатиричном RGB-представлении (как по умолчанию), либо
            ## имя файла с изображением (размеры изображения должны 
            ## совпадать с размерами экрана).
            gm_root = "Images/uni.jpg",

            ## Со схемой покончено. Дальнейшие изменения следует производить
            ## в стилях, чем можно заняться дальше по файлу.            
            )


        #########################################
        ## Эти параметры позволят вам изменить текстовое окно, куда выводятся
        ## реплики и комментарии, заменив его каким-либо изображением.

        ## Фон текстового окна. В Frame два числа -- это размеры границ, левой-правой
        ## и верхней-нижней соответственно

        # style.window.background = Frame("frame.png", 12, 12)
        
        ## margin -- это окружающее окно пространство, где фон не выводится.
        
        # style.window.left_margin = 6
        # style.window.right_margin = 6
        # style.window.top_margin = 6
        # style.window.bottom_margin = 6
        
        ## padding -- это пространство в окне, где отображается фон.


        # style.window.left_padding = 6
        # style.window.right_padding = 6
        # style.window.top_padding = 6
        # style.window.bottom_padding = 6

        ## Это -- минимальная высота окна, включая margin и padding

        # style.window.yminimum = 250


        #########################################
        ## С помощью этих параметров можно поменять место расположения
        ## главного меню
        
        ## Делается это так: Находится точка привязки (anchor) внутри объекта
        ## и точка расположения (pos) на экране. Объект выводится на экран
        ## таким образом, чтобы эти две точки совпали.

        ## Значением может быть целое число, или десятичная дробь.
        ## Целое число воспринимается как число пикслей от верхнего левого края.
        ## Десятичная дробь -- как доли ширины/высоты.

        # style.mm_menu_frame.xpos = 0.5
        # style.mm_menu_frame.xanchor = 0.5
        # style.mm_menu_frame.ypos = 0.75
        # style.mm_menu_frame.yanchor = 0.5


        #########################################
        ## Тут можно подправить шрифт, используемый по умолчанию.

        ## Файл шрифта по умолчанию.

        # style.default.font = "DejaVuSans.ttf"

        ## Размр шрифта по умолчанию.

        # style.default.size = 22

        ## Однако, сие управляет размером не всего текста.
        ## У разных элементов итерфейса свои стили.


        #########################################
        ## Эти параметры позволят изменить звуковое сопровождение

        ## Если в игре не будет звуковых эффектов, установите этот параметр в False.
        config.has_sound = True

        ## Если в игре не будет музыки, установите этот параметр в False.

        config.has_music = True

        ## Если в игре не будет голосового сопровождения, установите этот параметр в False.

        config.has_voice = True

        ## Звуки, издаваемые игрой при нажатии на элементы управления.

        # style.button.activate_sound = "click.wav"
        # style.imagemap.activate_sound = "click.wav"

        ## Звуки, издаваемые игрой при входе и выходе из внутриигрового меню.
        
        # config.enter_sound = "click.wav"
        # config.exit_sound = "click.wav"

        ## Звук, используемый для проверки громкости звучания в Настройках.

        config.sample_sound = "Sound/click.wav"

        ## Музыка, играющая в главном меню.

        # config.main_menu_music = "main_menu_theme.ogg"

        #########################################
        ## Эффекты перехода.

        ## Используемый при переходе в внутриигровое меню из игры.
        config.enter_transition = None

        ## Используемый при переходе в игру из внутриигрового меню.
        config.exit_transition = None

        ## Используемый при переходе между экранами внутриигрового меню.
        config.intra_transition = None

        ## Используемый при переходе в внутриигровое меню из главного меню.
        config.main_game_transition = None

        ## Используемый при переходе в главное меню из игры.
        config.game_main_transition = None

        ## Используемый при переходе в главное меню из экрана заставки. 
        config.end_splash_transition = None

        ## Используемый при возврате в главное меню по завершению игры.
        config.end_game_transition = None
        
        
        #########################################
        ## Значения параметров Настроек по умолчанию.

        ## Эти значения используются только при саамом первом запуске игры.
        ## Чтобы они сработали снова, нужно удалить game/saves/persistent
        
        ## Запускать в полноэкранном режиме? True -- да, False -- нет.
        config.default_fullscreen = False

         ## Скорость вывода текста по умолчанию, в знаках в секунду. 0 -- мгновенно.
        config.default_text_cps = 0
        
