﻿init:
    #Фоны
    image black = "#000000"
    image bg uni = "Images/uni.jpg"
    image bg lecturehall = "Images/class.jpg"
    
    #Изображения персонажей
    image yuki norm = "Images/yuki_norm.png"
    image yuki smile = "Images/yuki_smile.png"
    image prof norm = "Images/prof_norm.png"
    image prof smile = "Images/prof_smile.png"

    #Персонажи
    $ p = Character(u'Профессор Наталь', color="#ff6666")
    $ y = Character(u'Юки', color="#cccccc")
    
    #Переменные
    $ ppoints = 0
    $ gameplay_asked = False
    
# А здесь, собственно, начинается игра.
label start:
    play music "Sound/mozart.ogg"                                                              # Запуск фоновой музыки. По достижению конца файла автоматически запустится сначала.
    
    scene bg uni with dissolve                                                                       # Демонстрируем фон, с эффектом dissolve.
    "Интернациональный Колледж Цифровых Искусств."                                  # Высказывание -- основной способ вывода информации. Выводит текст в текстовое окно.
    "Мне повезло, что я учусь здесь. \nОсобенно, что на игровом направлении."     #Сочетание символов \n вызывает переход на новую строку
    "Ладно, нет времени любоваться пейзажем, а то опоздаю к началу занятий."
    "Сейчас по расписанию \"Визуальные новеллы\". Новый курс. Интересно, о чём же нам там поведают?" #Перед символом " в высказывании надо ставить косую черту. 
    
    scene bg lecturehall with fade                                                                      # Меняем фон, с эффектом fade.
    "..."
    "......."
    ".........."
    "{i}Преподаватель опаздывает.{/i}"                                                             # Тэг {i}...{/i} делает заключённый в него текст курсивным.
    "Стоило мне так подумать, как от дверей зала послышался шум."
    "Двери открылись, пропуская в зал молодую женщину в тёмно-синем костюме."
    show prof norm at center with moveinright                                                       # Демонстрируем изображение персонажа в центре экрана с выездом справа.
    "Она оглядела зал и обратилась к нам:"
    "???" "Здравствуйте! Простите за эту задержку."
    "???" "Я -- профессор Наталь, и я буду вести у вас курс \"Визуальные Новеллы\"."
    "Профессор Наталь дала этой информации осесть в разумах слушателей и начала лекцию."
    p "Прежде всего, что такое \"визуальная новелла\"?"
    "Она вновь оглядела нас."
    p "Вижу, что многие никогда не сталкивались с этим понятием. Что ж, тогда начнём с академического определения:"
    p "Визуальная новелла -- это интерактивное мультимедийное средство повествования."
    "Профессор сделала паузу, снова оглядывая зал."
    
    # Меню -- основное средство взаимодействия с игроком.
    menu:
        "Хорошая возможность задать вопрос."                                                    # Фраза, которая будет в текстовом окне при демонстрации меню.
        "А как это выглядит с точки зрения игрока?":                                           # Пункт меню 1.
            "Я поднял руку, показывая, что у меня есть вопрос."                                         #Блок результатов выбора пункта меню
            p "Да?"
            u"Я" "Вы говорите, что визуальная новелла -- это средство повествования."
            u"Я" "Но ведь это с точки зрения разработчика. А с точки зрения игрока?"
            p "Полностью сюжетно-ориентированная игра."
            u"Я" "То есть, весь игровой аспект подчинён задаче рассказать игроку некую историю?"
            p "Верно."
            u"Я" "А реализуется он -- игровой аспект то есть -- тогда как?"
            $ gameplay_asked = True                                                                     # Логические переменные хранят информацию в виде состояния истинно/ложно
            p "А вы как думаете?"
            # Ещё одно меню.
            menu:
                "{i}И правда, как же игрок может взаимодействовать с полностью сюжетно-ориентированной игрой?{/i}"
                "Игрок продвигается по сюжету только после выполнения каких-то условий?":               # Пункт меню 2.
                    u"Я" "Раз сюжет стоит во главе..."
                    u"Я" "Может, игрок продвигается по сюжету только после выполнения каких-то условий?"
                    u"Я" "Например, найти ключевой предмет или решить загадку?"
                    p "Конечно, возможно и это."
                    p "Но в общем, всё проще."
                    p "Обычно, в определённые моменты игроку предоставляется возможность сделать выбор, и от того, что игрок выберет, зависит ход истории визуальной новеллы."
                    p "Но мы с этим несколько забежали вперёд."
                "Выбор игрока влияет на течение повествования?":                                # Пункт меню 2.
                    u"Я" "Ну... Вы говорили об интерактивности..."
                    u"Я" "Получается, через возможность изменения игроком течения повествования?"
                    u"Я" "Игрок совершает выбор, и от него зависит дальнейший ход сюжета?"
                    $ ppoints += 1                                                                                 # Цифровые переменые хранят (никогда не догадаетесь) цифровые данные. А записываются также, как и логические со строковыми. (Обратите внимание, хоть комментарий и предстаёт на двух строчках, для движка строчка одна.)
                    show prof smile with dissolve                                                              # Демонстрируем изображение персонажа на прежнем месте с эффектом dissolve.
                    p "Правильно."
                    p "Обычно, в определённые моменты игроку предоставляется выбор, от которого зависит ход истории визуальной новеллы."
                    show prof norm with dissolve
                    p "Но мы с этим несколько забежали вперёд."
                "Не представляю":                                                                               # Пункт меню 2.
                    u"Я" "Ну... Не знаю."
                    p "Всё довольно просто."
                    p "Обычно, в определённые моменты игроку предоставляется выбор, от которого зависит ход истории визуальной новеллы."
            u"Я" "А как в целом визуальная новелла выглядит? Вы, конечно, упоминали мультимедийность, но..."
            p "Я как раз к этому перехожу."            
        "Ничего не спрашивать":                                                                                 # Пункт меню 1.
            pass      # Блок результатов выбора пункта меню обязан содержать хоть одну значащую строчку. Когда делать ничего не нужно, приходится использовать pass.
            
    p "Визуальные новеллы для передачи сюжета используют текст, изображения, музыку, звуки, и, возможно, видео."
    p "Правда, последнее применяется довольно редко. В основном, из-за трудоёмкости создания и значительного объёма конечного продукта."
    p "Вообще говоря, визуальная новелла похожа на хорошо иллюстрированную книгу с набором тематической музыки."
    "Слева от меня кто-то чуть слышно усмехнулся"
    menu:
        "Взглянуть.":
            jump yuki_branch                                                                                            # Переход по метке. Дальше игра будет исполняться с метки yuki_branch.  И не важно, что она в другом файле скрипта...
        "Не отвлекаться":
            pass
    p "Однако, в отличие от книги, сюжет визуальной новеллы вариативен."
    p "Игрок может повлиять на сюжет, через выборы, совершаемые по ходу игры."
    if gameplay_asked:                                                                                                  # Устовная конструкция "Если-то". Если gameplay_asked == True 
        p "Что я, впрочем, уже говорила."                                                                        # то выполняется эта строчка. Иначе она не выполняется...
    "И вновь профессор сделала паузу, словно ожидая вопросов."
    menu:
        "Может, и правда, спросить?"
        "Спросить, какая из составляющих важнее.":
            "Я поднял руку, показывая, что у меня есть вопрос."
            p "Да?"
            u"Я" "Вы говорите, что визуальная новелла состоит из текста, изображения и звука, музыки."
            u"Я" "А какой аспект важнее?"
            p "Я, конечно, могу ответить \"Все\"."
            p "Но ведь это будет не тот ответ, которого вы ждёте?"
            u"Я" "Ну..."
            p "А вы как думаете?"
            call submenu_priority from _call_submenu_priority_1                                                 # Вызов. Игра пойдёт по метке submenu_priority и, встретив return вернётся
            p "Важно добиться гармонии и взаимодополнения всех составляющих."                   # сюда.
            show prof smile with dissolve
            p "Другими словами, в хорошей визуальной новелле всё должно быть прекрасно, и литературная, и художественная состовляющие, и звучание."
            show prof norm with dissolve
            p "Правда, добиться этого нелегко."
        "Спросить о реализации визуальной новеллы.":
            "Я поднял руку, показывая, что у меня есть вопрос."
            p "Да?"
            u"Я" "А как, собственно, обычная визуальная новелла выглядит? С точки зрения воплощения?"
            p "Практически все визуальные новеллы в этом плане очень схожи."
            p "В них присутствует фоновое изображение, показывающее место действия, изображения персонажей, участвующих в сцене, и текстовое окно, в которое выводятся реплки персонажей и комментарии, описывающие происходящее в игре."
            p "Надо заметить, что изображение песонажа, от лица которого ведётся повествование, в сцене обычно не даётся. Считается. что это помогает игроку лучше ассоциировать себя с героем."
            p "Особо значимые моменты обычно сопровождаются полноэкранными картинами, заменяющими и фон, и изображения персонажей."
            show prof smile
            p "Часто такие картины являются своеобразной наградой игроку, и служат мотивацией для повторных прохождений по другим сюжетным линиям -- чтобы собрать их все."
            show prof norm
            p "Хотя основная мотивация повторного прохождения, конечно же, -- раскрыть сюжет в полной мере."
            p "И, полноэкранные картины -- это часто единственные изображения, на которых можно увидеть и героя."
            u"Я" "Хм, звучит довольно просто."
            u"Я" "Я уже вижу как сделать нечто подобное."
            show prof smile
            p "О, уже рвемся в бой?"
            $ ppoints += 1
            p "Что ж, похвально."
            show prof norm
            p "Но надо заметить, что воплощение визуальной новеллы и правда довольно простое."
            p "Однако, создание увлекательной истории, проработка вариантов хода сюжета, создание красивого графического сопровождения -- вот что по-настоящему делает создание визуальной новеллы непростым делом."
        "Спросить о её об оговорке, связанной с интерактивностью." if gameplay_asked:              #Этот пункт появится только если gameplay_asked == True
            "Кое-что в предыдущем ответе профессора меня смущало. Потому я решил уточнить для себя этот пункт."
            "Я поднял руку, показывая, что у меня есть вопрос."
            p "Да?"
            u"Я" "Вы, когда отвечали на мой вопрос о том, как визуальная новелла выглядит с точки зрения игрока и говорили о возможности игрока влиять на ход повествования, сказали \"Обычно\"."
            u"Я" "То есть, может быть и неинтерактивная визуальная новелла?"
            p "Вообще говоря, да. Существуют визуальные новеллы, не предоставляющие игроку никакой возможности влиять на сюжет."
            p "Это так называемые кинетические новеллы."
            p "По сути, это электронные книги."            
            u"Я" "Но разве это не противоречит определению визуальной новеллы?"
            p "Противоречит.  Одному пункту. Однако воплощение полностью совпадает."
            p "Поэтому кинетические новеллы и вынесенны в собственный вид, но при этом формально считаются подвидом визуальнх новелл."
            
    play sound "Sound/call03.wav"                                                    # Проигрываем звуковой файл единожды.
    $ renpy.pause (2.0)                                                                  # Пауза на 2 секунды, чтобы сигнал успел отзвучать. 
    p "Ох, уже?"
    p "Что ж, сделаем паузу. Можете идти на перерыв."
    
    if ppoints == 2:
        show prof smile
        p "И, я с нетерпением жду продолжения занятия с вами!"
        scene black with fade
        centered "Поздравляю, вы пришли к лучшему окончанию!"
    elif ppoints == 1:
        p "Надеюсь, вам было интересно."
        scene black with fade
        centered "Поздравляю, вы пришли к хорошему окончанию."
    else:
        scene black with fade
        centered "Нормальное окончание."
 
label credits:
    $ renpy.pause (2.0)
    "Сюжет (если это слово сюда конечно подходит) и скрипт : 000"
    scene bg lecturehall with dissolve
    "Фоновые изображения : слегка отфильтрованные фотографии из архива www.morguefile.com"
    show yuki norm at left
    show prof norm at right
    with dissolve
    "Изображения персонажей : сгенерированы кукольной программой ALICE (Copyright 2005 PyTom <pytom@bishoujo.us>)"
    scene black with fade
    "Музыка : сгенерирована на основе Musikalisches Würfelspiel Моцарта."
    "Звуки : позаимствованны из коллекции OSA © 2006 (http://osabisi.sakura.ne.jp/m2/)"
    "Данный продукт был создан с помощью движка визуальных новелл Ren'Py (http://www.renpy.org/)"
    "Надеюсь, вам было хоть немного интересно. Спасибо за внимание. Пока!"
return                                                                                                          # Конец игры. Возврат в главное меню.

label submenu_priority:                                                                                    # Ветка, в которую игра попадёт с помощью call'a. И только с помощью него.
    menu:
        "{i}Что важнее для визуальной новеллы? Наверное, это...{/i}"
        "Графика":
            u"Я" "Графика. Всё же, это то, на что игрок обратит внимание в первую очередь."
            p "Да, люди имеют обыкновение обращать внимание на внешнюю сторону в первую очередь."
            p "Но, по моему скромному мнению, содержание всё же важнее."
            u"Я" "Вы имеете в виду сюжет?"
            u"Я" "Но вы же сами говорили, что визуальные новеллы используют для его передачи изображение!"
            p "Текст, изображение, музыку, звук."
            p "При этом тексту, всё же, отводится основная роль."
            p "Словами можно сказать многое, что картинками было бы передать затруднительно. И это гораздо менее трудоёмко."
            p "Что, впрочем, нисколько не умаляет роль графики. Изображения тоже многое передают."
            p "И, что правда, не важно, насколько хороша литературная составляющая, если у твоей игры страшная графика, ею мало кто заинтересуется. Такова жизнь."
        "Текст":
            u"Я" "Текст. Текстом в играх передаётся большая часть сюжетной информации. И от его литературных свойств сильно зависит отношение игрока к сюжету."
            p "Верно. Для визуальных новелл это особенно важно. Ведь игрок проводит подавляющую часть игрового времени читая."
            p "Однако, это не значит, что другие составляющие не важны."
            p "Графика несёт важную дополняющую информацию, помогая игроку представить игровые события и вжиться в сюжет."
            p "Кроме того, создателям не приходится тратить слова на описание ситуаций."
            p "А звуковое сопровождение играет очень важную роль в создании атмосферы."
        "Звук":
            u"Я" "Музыка и звуки. Именно правильно подобраное звуковое сопровождение и создаёт нужную атмосферу."
            p "Конечно, роль звукового сопровождения в создании атмосферы огромна."
            p "Но оно всё равно остаётся сопровождением. Основную сюжетную информацию несут текст и изображение."
return                                                                                                          # Возврат в точку вызова.
